function varargout = Delaunay_muscle_areas(varargin)
% DELAUNAY_MUSCLE_AREAS MATLAB code for Delaunay_muscle_areas.fig
%      DELAUNAY_MUSCLE_AREAS, by itself, creates a new DELAUNAY_MUSCLE_AREAS or raises the existing
%      singleton*.
%
%      H = DELAUNAY_MUSCLE_AREAS returns the handle to a new DELAUNAY_MUSCLE_AREAS or the handle to
%      the existing singleton*.
%
%      DELAUNAY_MUSCLE_AREAS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DELAUNAY_MUSCLE_AREAS.M with the given input arguments.
%
%      DELAUNAY_MUSCLE_AREAS('Property','Value',...) creates a new DELAUNAY_MUSCLE_AREAS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Delaunay_muscle_areas_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Delaunay_muscle_areas_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Delaunay_muscle_areas

% Last Modified by GUIDE v2.5 14-Aug-2019 16:05:43

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Delaunay_muscle_areas_OpeningFcn, ...
                   'gui_OutputFcn',  @Delaunay_muscle_areas_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Delaunay_muscle_areas is made visible.
function Delaunay_muscle_areas_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Delaunay_muscle_areas (see VARARGIN)

% Choose default command line output for Delaunay_muscle_areas
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Delaunay_muscle_areas wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Delaunay_muscle_areas_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton_loadfile.
function pushbutton_loadfile_Callback(hObject, eventdata, handles)

cd('C:\Users\John\Desktop');

%Read results file%
[handles.filename,handles.pathname]=uigetfile({'*.*'},'Pick an XYZ points file');

if handles.filename==0
    return
end

handles.file=fullfile(handles.pathname,handles.filename);

fid=fopen(handles.file);
handles.Data=dlmread(handles.file,',',0,0);
handles.DataReduced=handles.Data-mean(handles.Data);

set(handles.edit_filename,'String',handles.filename);
set(handles.edit_surfacearea,'String','');
set(handles.radiobutton_xy,'Value',1);
set(handles.radiobutton_yz,'Value',0);
set(handles.radiobutton_xz,'Value',0);
set(handles.edit_alphaparameter,'String','');
set(handles.radiobutton_usealpha,'Value',0);

handles.triangulated=0;

arrayfun(@cla,findall(0,'type','axes'))

guidata(hObject, handles);
mydisplay1(hObject, eventdata, handles)
% hObject    handle to pushbutton_loadfile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


function mydisplay1(hObject, eventdata, handles)

axes(handles.axes1);

if handles.triangulated==0       %Plot just the point cloud
    scatter3(handles.DataReduced(:,1),handles.DataReduced(:,2),handles.DataReduced(:,3),10,'filled','r')
else            %Plot the point cloud and the triangulation
    if get(handles.radiobutton_usealpha,'value')==0
        scatter3(handles.DataReduced(:,1),handles.DataReduced(:,2),handles.DataReduced(:,3),10,'filled','r')
        hold on
        trisurf(handles.triangulation,handles.DataReduced(:,1),handles.DataReduced(:,2),handles.DataReduced(:,3));
        hold off
    else
        scatter3(handles.DataReduced(:,1),handles.DataReduced(:,2),handles.DataReduced(:,3),10,'filled','r')
        hold on
        trisurf(handles.triangulation,handles.alphavertices(:,1),handles.alphavertices(:,2),handles.alphavertices(:,3),'facealpha', '0.5');
        hold off
    end
end
xlabel('X');
ylabel('Y');
zlabel('Z');
rotate3d on
axis equal
axis vis3d

guidata(hObject, handles);


% --- Executes on button press in pushbutton_calculate.
function pushbutton_calculate_Callback(hObject, eventdata, handles)

%Either:
% (A) generate Delaunay triangulation based on two components of the coordinates
%of point; the fully 3D surface is then generated by simply projecting each 
%triangle vertex in the direction of the final component as specified by 
%the points' final component coordinate.
% or
% (B) generate tight-fitting alpha shape to the three-dimensional
% coordinates directly (useful for highly curved attachment areas)

if get(handles.radiobutton_xy,'value')==1
    handles.triangulation = delaunay(handles.DataReduced(:,1),handles.DataReduced(:,2));    
elseif  get(handles.radiobutton_yz,'value')==1
    handles.triangulation = delaunay(handles.DataReduced(:,2),handles.DataReduced(:,3));  
elseif get(handles.radiobutton_xz,'value')==1
    handles.triangulation = delaunay(handles.DataReduced(:,1),handles.DataReduced(:,3));  
elseif get(handles.radiobutton_usealpha,'value')==1
    %Get alpha parameter
    alpha_parameter = str2double(get(handles.edit_alphaparameter,'String'));
    AS = alphaShape(handles.DataReduced(:,1),handles.DataReduced(:,2),handles.DataReduced(:,3),alpha_parameter);
    [handles.triangulation, handles.alphavertices] = boundaryFacets(AS);
else beep
     msgbox('Please select an option!','Oops!','warn','modal');
end

handles.triangulated=1;

%Calculate total area of the 3-D projected triangulation; this is done by 
%summing the areas of each individual triangle

NumTriangles=size(handles.triangulation,1);
totalarea=0;
if get(handles.radiobutton_usealpha,'value')==0
    for i=1:NumTriangles
        vertex1=[handles.DataReduced(handles.triangulation(i,1),1),handles.DataReduced(handles.triangulation(i,1),2),handles.DataReduced(handles.triangulation(i,1),3)];
        vertex2=[handles.DataReduced(handles.triangulation(i,2),1),handles.DataReduced(handles.triangulation(i,2),2),handles.DataReduced(handles.triangulation(i,2),3)];
        vertex3=[handles.DataReduced(handles.triangulation(i,3),1),handles.DataReduced(handles.triangulation(i,3),2),handles.DataReduced(handles.triangulation(i,3),3)];
        
        %Compute area using cross product
        area=0.5*norm(cross(vertex2-vertex1,vertex3-vertex1));
        
        %Add to cumulative area total
        totalarea=totalarea+area;
    end
else
    for i=1:NumTriangles
        vertex1=[handles.alphavertices(handles.triangulation(i,1),1),handles.alphavertices(handles.triangulation(i,1),2),handles.alphavertices(handles.triangulation(i,1),3)];
        vertex2=[handles.alphavertices(handles.triangulation(i,2),1),handles.alphavertices(handles.triangulation(i,2),2),handles.alphavertices(handles.triangulation(i,2),3)];
        vertex3=[handles.alphavertices(handles.triangulation(i,3),1),handles.alphavertices(handles.triangulation(i,3),2),handles.alphavertices(handles.triangulation(i,3),3)];
        
        %Compute area using cross product
        area=0.5*norm(cross(vertex2-vertex1,vertex3-vertex1));
        
        %Add to cumulative area total
        totalarea=totalarea+area;
    end
end

set(handles.edit_surfacearea,'String',totalarea);

guidata(hObject, handles);
mydisplay1(hObject, eventdata, handles)
% hObject    handle to pushbutton_calculate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton_export.
function pushbutton_export_Callback(hObject, eventdata, handles)

prompt={'Input'};
title='Specify file name';
answer=inputdlg(prompt,title, 1, {'' ''}, 'on');
exportname=[answer{1,1},'.obj'];

if get(handles.radiobutton_usealpha,'value')==0
    ExportMesh.vertices=handles.Data;
else
    ExportMesh.vertices=handles.alphavertices+mean(handles.Data);
end

%Create data structure to be exported to OBJ format
ExportMesh.material=[];
ExportMesh.vertices_point=[];
ExportMesh.vertices_normal=[];
ExportMesh.vertices_texture=[];
ExportMesh.objects(1).data=struct('vertices',handles.triangulation,'texture',[],'normal',handles.triangulation);
ExportMesh.objects(1).type='f';

%Export OBJ file
write_wobj(ExportMesh,exportname)

guidata(hObject, handles);
% hObject    handle to pushbutton_export (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function edit_filename_Callback(hObject, eventdata, handles)
% hObject    handle to edit_filename (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_filename as text
%        str2double(get(hObject,'String')) returns contents of edit_filename as a double


% --- Executes during object creation, after setting all properties.
function edit_filename_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_filename (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function edit_alphavalue_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_alphavalue (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_surfacearea_Callback(hObject, eventdata, handles)
% hObject    handle to edit_surfacearea (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_surfacearea as text
%        str2double(get(hObject,'String')) returns contents of edit_surfacearea as a double


% --- Executes during object creation, after setting all properties.
function edit_surfacearea_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_surfacearea (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in radiobutton_xy.
function radiobutton_xy_Callback(hObject, eventdata, handles)

set(handles.radiobutton_xy,'Value',1);
set(handles.radiobutton_yz,'Value',0);
set(handles.radiobutton_xz,'Value',0);
set(handles.radiobutton_usealpha,'Value',0);

guidata(hObject, handles);
% hObject    handle to radiobutton_xy (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton_xy


% --- Executes on button press in radiobutton_yz.
function radiobutton_yz_Callback(hObject, eventdata, handles)

set(handles.radiobutton_xy,'Value',0);
set(handles.radiobutton_yz,'Value',1);
set(handles.radiobutton_xz,'Value',0);
set(handles.radiobutton_usealpha,'Value',0);

guidata(hObject, handles);
% hObject    handle to radiobutton_yz (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton_yz


% --- Executes on button press in radiobutton_xz.
function radiobutton_xz_Callback(hObject, eventdata, handles)

set(handles.radiobutton_xy,'Value',0);
set(handles.radiobutton_yz,'Value',0);
set(handles.radiobutton_xz,'Value',1);
set(handles.radiobutton_usealpha,'Value',0);

guidata(hObject, handles);
% hObject    handle to radiobutton_xz (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton_xz


% --- Executes on button press in radiobutton_usealpha.
function radiobutton_usealpha_Callback(hObject, eventdata, handles)

set(handles.radiobutton_xy,'Value',0);
set(handles.radiobutton_yz,'Value',0);
set(handles.radiobutton_xz,'Value',0);
set(handles.radiobutton_usealpha,'Value',1);

guidata(hObject, handles);
% hObject    handle to radiobutton_usealpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton_usealpha



function edit_alphaparameter_Callback(hObject, eventdata, handles)
% hObject    handle to edit_alphaparameter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_alphaparameter as text
%        str2double(get(hObject,'String')) returns contents of edit_alphaparameter as a double


% --- Executes during object creation, after setting all properties.
function edit_alphaparameter_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_alphaparameter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
